package {
	import ru.cleptoman.starling.builder.extension.AssetMediator;
	import ru.cleptoman.starling.builder.extension.UIBuilder;
	import starling.display.Sprite;
	
	/**
	 * ...
	 * @author Aleksey Kutov aka cleptoman
	 */
	public class StarlingRoot extends Sprite {
		
		private static const PATH_PREFIX:String = "../workspace/";
		private static const LAYOUT:String = "test_layout";
		private static const RESOURCES:String = "ui";
		
		private var _assets:AssetMediator;
		private var _builder:UIBuilder;
		private var _window:Window;
		
		public function StarlingRoot() {
			super();
			/**
			 * созадем билдер
			 */
			_assets = new AssetMediator();
			_assets.verbose = true;
			
			_builder = new UIBuilder(_assets);
			
			/**
			 * добавляем ресурсы в очередь
			 */
			addResourcesToQueue(RESOURCES);
			/**
			 * добавляем конфиг окошка в загрузку
			 */
			addLayoutConfigToQueue(LAYOUT);
			
			/**
			 * грузим
			 */
			_assets.loadQueue(onLoadProgress);
		}
		
		private function onLoadProgress(ratio:Number):void {
			if (ratio < 1) return;
			/**
			 * теперь строим наше окошко
			 */
			_window = _builder.buildByName(LAYOUT) as Window;
			addChild(_window);
		}
		
		private function addResourcesToQueue(name:String):void {
			_assets.enqueue(PATH_PREFIX + "textures/"  +name + ".xml");
			_assets.enqueue(PATH_PREFIX + "textures/"  +name + ".png");
		}
		
		private function addLayoutConfigToQueue(name:String):void {
			_assets.enqueue(PATH_PREFIX + "layouts/"  + name + ".json");
		}
		
	}

}